{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XBevCtl.pas                                 }
{   Version:        V 0.2                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Enhanced Bevel Control                      }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  01/21/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/11/99   V0.1 -  First Version.                          }
{    01/21/99   V0.2 -  Enhanced functions, correct few bugs.   }
{                                                               }
{   Gratefulness: * Brad Stowers for all componets, great work  }
{                   thanks for all.                             }
{                   e-mail: bstowers@pobox.com                  }
{                   http://www.pobox.com/~bstowers/delphi/      }
{                                                               }
{                 * Kerstin Thaler for component sTktMultiBevel }
{                   thansk for all.                             }
{                   e-mail: MuK.Thaler@T-Online.de              }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XBevCtl;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs;             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}

    Classes, Graphics,              { Default Units }

    GraphExt, XObjects,             { My Units      }
    XCtrlCls;

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

type

{
// --------------------------------------------------------
//  TEnhBevel Control Class
// --------------------------------------------------------
}

  TEnhBevel = class(TEnhGraphicControl)
  private
    { Variables for properties }
    FBevel    : TObjBevel;

    procedure SetBevel(Value : TObjBevel);

  protected

    procedure PaintDC(DC: HDC); override;
//    procedure Resize; override;
//    function  GetPalette:HPalette; override;

  public

    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

    function    IsEmpty: Boolean; override;

//    procedure   Assign(Source:TPersistent); override;

  published

    property   Bevel   : TObjBevel read FBevel    write SetBevel;

    {*** ***}

    property Align;
//    property DragCursor;
//    property DragMode;

    property Enabled;
//    property ParentShowHint;
    property PopupMenu;
    Property ShowHint;
    Property Visible;

    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    {$IFDEF WIN32}
    property OnStartDrag;
    {$ENDIF}

//    property   OnMouseEnter;
//    property   OnMouseLeave;

  end;


{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }


{
// --------------------------------------------------------
//
// --------------------------------------------------------
}
implementation

uses
    Controls;

{$ENDIF} { // PRG_UNIT }

{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
constructor TEnhBevel.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);                   { Parent Create         }

//    ControlStyle := ControlStyle + [csOpaque, csReplicatable];
//    FTransparent := False;
    ControlStyle := ControlStyle + [csReplicatable];

    FBevel    := TObjBevel.Create;
    FBevel.OnChange := GetChange;

end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
destructor TEnhBevel.Destroy;
begin
    FBevel.OnChange := nil;
    FBevel.Free;
    inherited Destroy;
end;

{
// --------------------------------------------------------
//  Copy Gradient Data
// --------------------------------------------------------
}
//function TEnhBevel.GetPalette: HPALETTE;
//begin
//    Result := 0;
//end;

{
// --------------------------------------------------------
//  Copy Bevel Data
// --------------------------------------------------------
}
procedure TEnhBevel.SetBevel(Value : TObjBevel);
Begin
    FBevel.Assign(Value);
End;


{
// --------------------------------------------------------
//  Return if Control is empty to draw
// --------------------------------------------------------
}
function TEnhBevel.IsEmpty: Boolean;
begin
    Result := FBevel.IsEmpty;
end;


{
// --------------------------------------------------------
//  Default Paint
// --------------------------------------------------------
}
procedure TEnhBevel.PaintDC(DC : HDC);
Begin
    FBevel.PaintDC(DC,Rect(0,0,Width,Height));
end;

//procedure TEnhBevel.Resize;
//begin
//    inherited Resize;
//    NotifyControls(CM_ColorChanged);
//end;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
