{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XBev_PE.pas                                 }
{   Version:        V 0.1                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    EnhBevel Property Editor                    }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  01/20/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/20/99   V0.1 -  First relase version                    }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XBev_PE;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}  { // WIN32 }

  Graphics, Classes, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, DsgnIntF,

  GraphExt,                         { My Unit       }
  XObjects,
  XCtrlStd;


{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }


{$IFDEF DFS_DELPHI_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}  { // DFS_DELPHI_3_UP }

    Str_Bevel_Title = 'EnhBevel Editor';
    Str_Outer    = 'Outer';
    Str_Inner    = 'Inner';

    Str_BevStyle_Efects =  'None'   +
                        #13'Lowered'+
                        #13'Raised' +
                        #13'Light'  +
                        #13'Shadow';


type

{
// --------------------------------------------------------
//  EnhBevel Property Dialog Class
// --------------------------------------------------------
}
  TEnhBevelEditDlg = class(TForm)

    PBevel: TEnhBevel;

    CD: TColorDialog;
    Label01: TLabel;
    Label02: TLabel;
    Bevel3: TBevel;
    Label4: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    EnhBevel1: TEnhBevel;
    EnhBevel2: TEnhBevel;
    EnhBevel3: TEnhBevel;
    EnhBevel4: TEnhBevel;

    EB_Inner  : TEnhBevel;
    EB_Outer  : TEnhBevel;
    EB_Sides : TEnhBevel;

    SE_Width1: TSpinEdit;
    SE_Width2: TSpinEdit;
    CB_Style : TComboBox;
    CB_FixColor   : TCheckBox;
    CB_Transparent: TCheckBox;
    CB_Custom : TCheckBox;

    P1: TPanel;
    P2: TPanel;
    P3: TPanel;

    About    : TButton;
    Btn_Ok    : TButton;
    Btn_Cancel: TButton;

    PanelData: TPanel;
    CB_Left  : TCheckBox;
    CB_Top   : TCheckBox;
    CB_Right : TCheckBox;
    CB_Bottom: TCheckBox;


    procedure FormCreate(Sender: TObject);
//    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);

    procedure NewColor(Sender: TObject);
    procedure ChangeData(Sender: TObject);
    procedure FrameClick(Sender: TObject);

  private   { Private declarations }

    FUpdate     : Boolean;
    CtrlView    : Byte;

    procedure UpdateCtrls;

  end;

{
// --------------------------------------------------------
//  Editor to Property ObjBevel Class
// --------------------------------------------------------
}
  TObjBevelProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{
// --------------------------------------------------------
//  Editor to Component EnhBevel
// --------------------------------------------------------
}
  TEnhBevelComponentEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index:Integer);override;
    function  GetVerb(Index: Integer): string; override;
    function  GetVerbCount: Integer; override;
  end;


{
// --------------------------------------------------------
//  Util Function
// --------------------------------------------------------
}
function GetNewBevel(Bev: TObjBevel): Boolean;


{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }


implementation

Uses
     SysUtils, TypInfo, SysUtlEx;

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{$IFDEF PRG_UNIT}
{$R *.DFM}
{$ELSE}
{$R XBev_PE.DFM}
{$ENDIF}

const

    PanelDataWidth1 = 120;
    PanelDataWidth2 = 194;
{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.FormCreate(Sender: TObject);
begin

    Caption := Str_Bevel_Title;

//  Label1.Caption := Str_Width;
//  Label2.Caption := Str_Outer;
//  Label4.Caption := Str_Style;
//  Label5.Caption := Str_Color;
//  Label6.Caption := Str_Light;
//  Label7.Caption := Str_Shadow;
//  Label8.Caption := Str_Border;
//  Label9.Caption := Str_Border;
//  Label10.Caption:= Str_Outer;
//  Label11.Caption:= Str_Inner;
//
    About.OnClick    := ChangeData;
    Btn_Ok.Caption     := Str_Btn_Ok;
    Btn_Cancel.Caption := Str_Btn_Cancel;

    PanelData.Visible:= False;
    PanelData.Width  := PanelDataWidth1;
    CtrlView := 0;

    EB_Inner.OnClick := FrameClick;
    EB_Outer.OnClick := FrameClick;
    EB_Sides.OnClick := FrameClick;

    CB_Left.OnClick  := ChangeData;
    CB_Top.OnClick   := ChangeData;
    CB_Right.OnClick := ChangeData;
    CB_Bottom.OnClick:= ChangeData;


    With SE_Width1 do
    Begin
        MinValue := 0;
        MaxValue := Max_Bevel_Width;
        OnChange := ChangeData;
    End;

    With SE_Width2 do
    Begin
        MinValue := 0;
        MaxValue := Max_Bevel_Width;
        OnChange := ChangeData;
    End;

    With CB_Style do
    Begin
        Items.Text:= Str_BevStyle_Efects;              { Put names of all efects }
        OnChange  := ChangeData;
    End;

    with CB_FixColor do
    begin
        Caption := Str_FixColor;
        OnClick := ChangeData;
    end;

    with CB_Transparent do
    begin
        Caption := Str_Transparent;
        OnClick := ChangeData;
    end;

    P1.OnClick := NewColor;
    P2.OnClick := NewColor;
    P3.OnClick := NewColor;

    FUpdate := False;
end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
//procedure TEnhBevelEditDlg.FormDestroy(Sender: TObject);
//begin
    // FBevel.Free;
//end;

{
// --------------------------------------------------------
//  Activate Handle
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.FormActivate(Sender: TObject);
begin
    if (not FUpdate) then
        FUpdate := True;
end;


{
// --------------------------------------------------------
//  Reset all vars
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.UpdateCtrls;
Var
    TmpSides : TEnhSides;
    ChkEnable : Boolean;

Begin

    with PBevel.Bevel do
    Begin

        if (CtrlView = 1) then
        begin
            CB_Style.ItemIndex:= Integer(InnerStyle);
            SE_Width1.Value   := InnerWidth;
            SE_Width2.Value   := BorderInnerWidth;
            TmpSides := InnerSides;
        end
        else if (CtrlView = 2) then
        begin
            CB_Style.ItemIndex:= Integer(OuterStyle);
            SE_Width1.Value   := OuterWidth;
            SE_Width2.Value   := BorderOuterWidth;
            TmpSides := OuterSides;
        end;

        CB_Left.Checked   := Boolean(esdLeft   in TmpSides);
        CB_Right.Checked  := Boolean(esdRight  in TmpSides);
        CB_Top.Checked    := Boolean(esdTop    in TmpSides);
        CB_Bottom.Checked := Boolean(esdBottom in TmpSides);

        P1.Color := LightColor;
        P2.Color := ShadowColor;
        P3.Color := BorderColor;

        CB_FixColor.Checked    := Boolean(ebmFixColor in Mode);
        CB_Transparent.Checked := Boolean(ebmTransparent in Mode);
        CB_Custom.Checked      := Boolean(ebmCustom in Mode);

        if (CB_Custom.Checked) then
            ChkEnable := True
        else
            ChkEnable := False;

        CB_Left.Enabled  := ChkEnable;
        CB_Right.Enabled := ChkEnable;
        CB_Top.Enabled   := ChkEnable;
        CB_Bottom.Enabled:= ChkEnable;

    end;
End;

{
// --------------------------------------------------------
//  Set Swap Option
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.ChangeData(Sender: TObject);
var
    TmpSides: TEnhSides;
    Idx : Integer;

Begin

    if not (FUpdate) then exit;

    Idx := (Sender as TComponent).Tag;

    if (Idx = 8) then
    begin
        MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);
        Exit;
    end;

    with PBevel.Bevel do
    Begin
        if (CtrlView <> 0) then
        begin
            case idx of
                1 : if (CtrlView = 1) then
                        InnerStyle := TEnhFrameStyle(CB_Style.ItemIndex)
                    else if (CtrlView = 2) then
                        OuterStyle := TEnhFrameStyle(CB_Style.ItemIndex);
                2 : if (CtrlView = 1) then
                        InnerWidth := Byte(SE_Width1.Value)
                    else if (CtrlView = 2) then
                        OuterWidth := Byte(SE_Width1.Value);
                3 : if (CtrlView = 1) then
                        BorderInnerWidth:= Byte(SE_Width2.Value)
                    else if (CtrlView = 2) then
                        BorderOuterWidth:= Byte(SE_Width2.Value);

                7 : if (ebmCustom in Mode) then
                    begin

                        TmpSides := [];

                        if (CB_Left.Checked) then
                            Include(TmpSides,esdLeft);

                        if (CB_Right.Checked) then
                            Include(TmpSides,esdRight);

                        if (CB_Top.Checked) then
                            Include(TmpSides,esdTop);

                        if (CB_Bottom.Checked) then
                            Include(TmpSides,esdBottom);

                        if (CtrlView = 1) then
                            InnerSides := TmpSides
                        else if  (CtrlView = 2) then
                            OuterSides := TmpSides;
                    end;
            end;

        end
        else
        begin
            if (Idx = 4) then
            begin
                if (CB_Custom.Checked) then
                    Mode := Mode + [ebmCustom]
                else
                    Mode := Mode - [ebmCustom];
            end
            else if (Idx = 5) then
            begin
                if (CB_Transparent.Checked) then
                    Mode := Mode + [ebmTransparent]
                else
                    Mode := Mode - [ebmTransparent];
            end
            else if (Idx <> 0) then
            begin
                if (CB_FixColor.Checked) then
                    Mode := Mode + [ebmFixColor]
                else
                    Mode := Mode - [ebmFixColor];
            end;

        end;
    end;

//    if (FUpdate) then
        UpdateCtrls;
End;


{
// --------------------------------------------------------
//  Default Handle Change Color
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.NewColor(Sender: TObject);
Var
    TmpCol: TColor;
    Idx : Integer;

Begin

    if not (FUpdate) then exit;

    if (CtrlView <> 0) then
        Exit;

    Idx := (Sender as TComponent).Tag;

    { Check what panel click }
    with PBevel.Bevel do
    Begin
        if (Idx = 1 ) then
            TmpCol := LightColor
        else if (Idx = 2) then
            TmpCol := ShadowColor
        else
            TmpCol := BorderColor;
    End;

    CD.Color  := TmpCol;

    { Execute Color Dialog  }
    if CD.Execute then
    Begin

        TmpCol := CD.Color;

        with PBevel.Bevel do
        Begin

            if (Idx = 1) then
                LightColor  := TmpCol
            else if (Idx = 2) then
                ShadowColor := TmpCol
            else
                BorderColor := TmpCol;

        end;

//        if (FUpdate) then
            UpdateCtrls;
    end;
end;

{
// --------------------------------------------------------
//  Create Panel Efects
// --------------------------------------------------------
}
procedure TEnhBevelEditDlg.FrameClick(Sender: TObject);
Var
    I : Integer;

begin

    I := (Sender as TComponent).Tag;

    if (I = 1) or (I = 2) then
        CtrlView := I;

    UpdateCtrls;

    if (I = 1) then
    begin
        { Move Panel }
        if (EB_Inner.Bevel.OuterStyle = efsRaised) then
        begin
            EB_Outer.Bevel.OuterStyle := efsRaised;
            EB_Inner.Bevel.OuterStyle := efsLowered;
            PanelData.Left := EB_Inner.Left;
            PanelData.Top  := EB_Inner.Top + EB_Inner.Height;
            PanelData.Visible := True;
        end
        else
        begin
            EB_Inner.Bevel.OuterStyle := efsRaised;
            PanelData.Visible := False;
            CtrlView := 0;
        end;
    end
    else if (I = 2) then
    begin
        { Move Panel }
        if (EB_Outer.Bevel.OuterStyle = efsRaised) then
        begin
            EB_Inner.Bevel.OuterStyle := efsRaised;
            EB_Outer.Bevel.OuterStyle := efsLowered;
            PanelData.Left := EB_Outer.Left + EB_Outer.Width - PanelData.Width;
            PanelData.Top  := EB_Outer.Top + EB_Inner.Height;
            PanelData.Visible := True;
        end
        else
        begin
            EB_Outer.Bevel.OuterStyle := efsRaised;
            PanelData.Visible := False;
            CtrlView := 0;
        end;
    end
    else
    begin
        if (EB_Sides.Bevel.OuterStyle = efsRaised) then
        Begin
            EB_Sides.Bevel.InnerStyle := efsRaised;
            EB_Sides.Bevel.OuterStyle := efsLowered;
            PanelData.Width := PanelDataWidth2;
        end
        else
        begin
            EB_Sides.Bevel.InnerStyle := efsLowered;
            EB_Sides.Bevel.OuterStyle := efsRaised;
            PanelData.Width := PanelDataWidth1;
        end;

        if (EB_Outer.Bevel.OuterStyle = efsLowered) then
            PanelData.Left := EB_Outer.Left + EB_Outer.Width - PanelData.Width;

    end

end;



{
// --------------------------------------------------------
// --------------------------------------------------------
// --------------------------------------------------------
}

{
// --------------------------------------------------------
//  Editor to Component EnhBevel
// --------------------------------------------------------
}
procedure TEnhBevelComponentEditor.ExecuteVerb(Index: Integer);
begin
    with TEnhBevel(Component) do
        case Index of

            0  : MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);
            1  : if not GetNewBevel(Bevel) then
                    exit;
        end;

    Designer.Modified;
end;

{
// --------------------------------------------------------
//  Menu to Component EnhBevel
// --------------------------------------------------------
}
function TEnhBevelComponentEditor.GetVerb(Index: Integer): string;
begin
    case index of
        0: Result := 'About';
        1: Result := '&Bevel';
  end;
end;

{
// --------------------------------------------------------
//  Number of items in Menu to Component EnhBevel
// --------------------------------------------------------
}
function TEnhBevelComponentEditor.GetVerbCount: Integer;
begin
    Result := 2;
end;


{
// --------------------------------------------------------
//  Editor to Property ObjBevel Class
// --------------------------------------------------------
}
procedure TObjBevelProperty.Edit;
Var

  tmpBevel : TObjBevel;

Begin

    TmpBevel := TObjBevel.Create;

  try

    TmpBevel.Assign(TObjBevel(Pointer(GetOrdValue)));

    { Execute Dialog Property Editor }
    if GetNewBevel(tmpBevel) then
        SetOrdValue(Longint(Pointer(TmpBevel)));   { Assign New Values }

  finally

    TmpBevel.Free;

  end;

end;

{
// --------------------------------------------------------
//  Atributtes of Property Editor ObjBevel
// --------------------------------------------------------
}
function TObjBevelProperty.GetAttributes: TPropertyAttributes;
Begin
    Result := [paDialog, paSubProperties, paMultiSelect];
End;


{
// --------------------------------------------------------
//  Execute Dialog Property Editor and copy data
// --------------------------------------------------------
}
function GetNewBevel(Bev: TObjBevel): Boolean;
Begin

    Result  := False;

    with TEnhBevelEditDlg.Create(Application) do
    begin

      try

        PBevel.Bevel.Assign(Bev);              { Copy all Settings     }

        UpdateCtrls;

        if (Showmodal = mrOK) then
        begin

          Bev.Assign(PBevel.Bevel);       { Copy New Settings     }
          Result := True;

        end;

      finally

        Free;

      end;

    end;
end;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
