{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XGrad_PE.pas                                }
{   Version:        V 0.4                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Gradient Property Editor                    }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  02/01/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/08/99   V0.1 -  First relase version                    }
{    01/21/99   V0.2 -  Update some modifictions on Based Class }
{                       (TObjGradient)                          }
{    01/23/99   V0.3 -  New Property editor (Cool), add new     }
{                       property : AutoFix Color                }
{    02/01/99   V0.4 -  Include new Class  Background and       }
{                       compiler directives.                    }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XGrad_PE;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}  { // WIN32 }


  Graphics, Classes, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, DsgnIntF,

  Spin, //

  GraphExt,                         { My Unit       }
  XObjects,
  XCtrlStd;


{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

{$IFDEF DFS_DELPHI_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}  { // DFS_DELPHI_3_UP }


    Str_Grad_Title   = 'Gradient Editor';
    Str_Begin_Color  = 'Begin Color';
    Str_End_Color    = 'End Color';
    Str_SwapColor    = 'Swap Colors';
    Str_AutoFix      = 'AutoFix Levels';
    Str_Levels       = '# Levels';
    Str_Waves        = '# Waves';
    Str_DPalette     = 'Dinamic Palette';

  {$IFDEF LIKEALLEFECTS}
    Str_GradStyle_Efects =  'Horizontal'     +
                        #13'Vertical'    +
                        #13'TopLeft'     +
                        #13'TopRight'    +
                        #13'BottomLeft'  +
                        #13'BottomRight' +
                        #13'Square';
//                        #13'Custom';
  {$ENDIF}  { // LIKEALLEFECTS }

type

{
// --------------------------------------------------------
//  Gradient Property Dialog Class
// --------------------------------------------------------
}
  TGradientEditDlg = class(TForm)
    P1: TPanel;
    P2: TPanel;
    Bevel1: TBevel;
    Panel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SE_Colors: TSpinEdit;
    SE_Waves: TSpinEdit;
    Btn_Ok: TButton;
    Btn_Cancel: TButton;
    About  : TButton;
    CB_Swap: TCheckBox;
    CB_Dinamic: TCheckBox;
    CB_AutoFix: TCheckBox;
    CBStyle: TComboBox;
    CD: TColorDialog;
    PEfects: TEnhBevel;
    Panel2 : TPanel;

    GPanel : TBackground;
    FillBack: TFillBackground;

    procedure FormCreate(Sender: TObject);
//    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);

    procedure NewEfects(Sender: TObject);
    procedure NewColor(Sender: TObject);
    procedure ChangeData(Sender: TObject);

  private   { Private declarations }

    FUpdate    : Boolean;

    procedure UpdateCtrls;
//    procedure EnableCtrls;

  end;


{
// --------------------------------------------------------
//  Editor to Property Gradient Class
// --------------------------------------------------------
}
  TGradientProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;


{
// --------------------------------------------------------
//  Util Function
// --------------------------------------------------------
}
function GetNewGradient(Grad: TObjGradient): Boolean;

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}


{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }


Implementation

Uses
     SysUtils, TypInfo, SysUtlEx;

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{$IFDEF PRG_UNIT}
{$R *.DFM}
{$ELSE}
{$R XGrad_PE.DFM}
{$ENDIF}

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
procedure TGradientEditDlg.FormCreate(Sender: TObject);
begin

    Caption := Str_Grad_Title;
    Label1.Caption := Str_Begin_Color;
    Label2.Caption := Str_End_Color;
    Label3.Caption := Str_Levels;
    Label6.Caption := Str_Efects;

    Btn_Ok.Caption     := Str_Btn_Ok;
    Btn_Cancel.Caption := Str_Btn_Cancel;

    About.OnClick := ChangeData;

    FillBack.Background.BackStyle := efbGradient;


  {$IFNDEF LIKEALLEFECTS}

    PEfects.Enabled := False;
    Panel2.Visible  := False;

  {$ELSE}

    With Panel2 do
    begin
        Visible:= False;
        Left   := PEfects.Left - Width;
        Top    := PEfects.Top;
    end;

    PEfects.OnClick := NewEfects;

    with CB_AutoFix do
    begin
        Caption := Str_AutoFix;
      {$IFDEF LIKEAUTOFIX}
        OnClick := ChangeData;
      {$ELSE}
        Enabled := False;
      {$ENDIF}  { // LIKEAUTOFIX }
    end;


    with CB_Swap do
    begin
        Caption := Str_SwapColor;
        OnClick := ChangeData;
    end;

    With CB_Dinamic do
    Begin
        Caption := Str_DPalette;
      {$IFDEF LIKEPALETTE}
        OnClick := ChangeData;
      {$ELSE}
        Enabled := False;
      {$ENDIF}  { // LIKEPALETTE }
    End;

    With CBStyle do
    Begin
        OnChange  := ChangeData;
        Items.Text:= Str_GradStyle_Efects;      { Put names of all efects }
        Label5.Caption := Str_Style;
    End;

    With SE_Waves do
    Begin
      {$IFDEF LIKEWAVE}
        MaxValue := Max_Waves;
        MinValue := Min_Waves;
        OnChange := ChangeData;
      {$ELSE}
        Enabled  := False;
        Label4.Enabled := False;
      {$ENDIF}  { // LIKEWAVE }
        Label4.Caption := Str_Waves;
    End;

  {$ENDIF} { // LIKEALLEFECTS }

    With SE_Colors do
    Begin
        MinValue := Min_Grad_Labels;
        MaxValue := Max_Grad_Labels;
        OnChange := ChangeData;
    End;

    P1.OnClick := NewColor;
    P2.OnClick := NewColor;

    FUpdate := False;
end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
//procedure TGradientEditDlg.FormDestroy(Sender: TObject);
//begin
    //
//end;

{
// --------------------------------------------------------
//  Activate Handle
// --------------------------------------------------------
}
procedure TGradientEditDlg.FormActivate(Sender: TObject);
begin
    if (not FUpdate) then
        FUpdate := True;
end;


{
// --------------------------------------------------------
//  Reset all vars
// --------------------------------------------------------
}
procedure TGradientEditDlg.UpdateCtrls;
Begin

    with FillBack.Background.Gradient do
    Begin

        SE_Colors.Value := ColorLevels;
        P1.Color := BeginColor;
        P2.Color := EndColor;

      {$IFDEF LIKEALLEFECTS}

      {$IFDEF LIKEWAVE}
        SE_Waves.Value  := Waves;
      {$ENDIF}  { // LIKEWAVE }

        CB_Swap.Checked    := Boolean(gfxSwap in Efects);

      {$IFDEF LIKEPALETTE}
        CB_Dinamic.Checked := Boolean(gfxDinamicPalette in Efects);
      {$ENDIF}  { // LIKEPALETTE }

      {$IFDEF LIKEAUTOFIX}
        CB_AutoFix.Checked := Boolean(gfxAutoFix in Efects);
      {$ENDIF}  { // LIKEAUTOFIX }


        CBStyle.ItemIndex  := Integer(Style);

      {$ENDIF} { // LIKEALLEFECTS }

    end;
End;

{
// --------------------------------------------------------
//  Set Swap Option
// --------------------------------------------------------
}
procedure TGradientEditDlg.ChangeData(Sender: TObject);
Var
    TmpFx : TEnhGradientFx;

Begin

    if not (FUpdate) then exit;

    with FillBack.Background.Gradient do
    Begin
        case (Sender as TComponent).Tag of
            1 : ColorLevels := SE_Colors.Value;

        {$IFDEF LIKEALLEFECTS}

        {$IFDEF LIKEWAVE}
            2 : Waves := SE_Waves.Value;
        {$ENDIF}  { // LIKEWAVE }


            3 : Style := TGradientStyle(CBStyle.ItemIndex);

            4 : Begin

                    TmpFx := [];

                    if (CB_Swap.Checked) then
                        Include(TmpFx,gfxSwap);

                {$IFDEF LIKEPALETTE}

                    if (CB_Dinamic.Checked) then
                        Include(TmpFx,gfxDinamicPalette);
                {$ENDIF}  { // LIKEPALETTE }

                {$IFDEF LIKEAUTOFIX}
                    if (CB_AutoFix.Checked) then
                        Include(TmpFx,gfxAutoFix);
                {$ENDIF}  { // LIKEAUTOFIX }

                    Efects := TmpFx;

                End;

        {$ENDIF} { // LIKEALLEFECTS }

            5:  MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);

        end;
    end;

//    if (FUpdate) then
        UpdateCtrls;
end;

{
// --------------------------------------------------------
//  Default Handle Change Color
// --------------------------------------------------------
}
procedure TGradientEditDlg.NewColor(Sender: TObject);
Var
    TmpCol: TColor;
    Idx  : Integer;
Begin

    if not (FUpdate) then exit;


    Idx := (Sender as TComponent).Tag;

    { Check what panel click }
    with FillBack.Background.Gradient do
    Begin
        if (Idx = 1 ) then
            TmpCol := BeginColor
        else
            TmpCol := EndColor;
    End;

    CD.Color  := TmpCol;

    { Execute Color Dialog  }
    if CD.Execute then
    Begin

        TmpCol := CD.Color;

        with FillBack.Background.Gradient do
        Begin

            if (Idx = 1) then
                BeginColor := TmpCol
            else
                EndColor := TmpCol;
        end;

//        if (FUpdate) then
            UpdateCtrls;

    end;
end;

{
// --------------------------------------------------------
//  Default Handle When click "Efects"
// --------------------------------------------------------
}
procedure TGradientEditDlg.NewEfects(Sender: TObject);
begin
        if (PEfects.Bevel.OuterStyle = efsLowered) then
        begin
            Panel2.Visible := False;
            PEfects.Bevel.OuterStyle := efsRaised;
        end
        else
        begin
            PEfects.Bevel.OuterStyle := efsLowered;
            Panel2.Visible := True;
        end;
end;


{
// --------------------------------------------------------
//  Editor to Property Gradient Class
// --------------------------------------------------------
}
procedure TGradientProperty.Edit;
Var
  tmpGrad : TObjGradient;

Begin

    TmpGrad := TObjGradient.Create;

  try

    TmpGrad.Assign(TObjGradient(Pointer(GetOrdValue)));

    { Execute Dialog Property Editor }
    if GetNewGradient(tmpGrad) then
        SetOrdValue(Longint(Pointer(TmpGrad)));   { Assign New Values }

  finally

    TmpGrad.Free;

  end;


end;

{
// --------------------------------------------------------
//  Atributtes of Property Editor
// --------------------------------------------------------
}
function TGradientProperty.GetAttributes: TPropertyAttributes;
Begin
    Result := [paDialog, paSubProperties, paMultiSelect];
End;


{
// --------------------------------------------------------
//  Execute Dialog Property Editor and copy data
// --------------------------------------------------------
}
function GetNewGradient(Grad: TObjGradient): Boolean;
Begin

    Result  := False;

    with TGradientEditDlg.Create(Application) do
    Begin

      try

        FillBack.Background.Gradient.Assign(Grad);              { Copy all Settings     }

        UpdateCtrls;

        if (Showmodal = mrOK) then
        begin

          Grad.Assign(FillBack.Background.Gradient);       { Copy New Settings     }
          Result := True;

        end;

      finally

        Free;

      end;

    end;
end;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
